"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = matchRoute;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function matchRoute(route, requestPath) {
  var values = route.matchPath.exec(requestPath);

  if (!values) {
    return null;
  }

  return values.slice(1).reduce(function (params, val, i) {
    if (val === undefined) return params;
    return _objectSpread({}, params, _defineProperty({}, route.keyNames[i], decodeURIComponent(val)));
  }, _objectSpread({}, route.params));
}